// TestPCSCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestPCSC.h"
#include "TestPCSCDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestPCSCDlg dialog

CTestPCSCDlg::CTestPCSCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestPCSCDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestPCSCDlg)
	m_Message = _T("");
	m_SelectedReaderInfo = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestPCSCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestPCSCDlg)
	DDX_Control(pDX, IDC_READER_SELECT_COMBO, m_ReaderSelectCombo);
	DDX_Text(pDX, IDC_EDIT_MESSAGE, m_Message);
	DDX_Text(pDX, IDC_SELECTED_READER, m_SelectedReaderInfo);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestPCSCDlg, CDialog)
	//{{AFX_MSG_MAP(CTestPCSCDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_CBN_SELCHANGE(IDC_READER_SELECT_COMBO, OnSelchangeReaderSelectCombo)
	ON_EN_CHANGE(IDC_EDIT_MESSAGE, OnChangeEditMessage)
	ON_BN_CLICKED(IDC_CONNECT_BTN, OnConnectBtn)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestPCSCDlg message handlers

BOOL CTestPCSCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	SCManager.m_FillReaderComboBox(&m_ReaderSelectCombo);

	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CTestPCSCDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestPCSCDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestPCSCDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTestPCSCDlg::OnSelchangeReaderSelectCombo() 
{

	m_ReaderSelectCombo.GetLBText(m_ReaderSelectCombo.GetCurSel(), SCManager.m_SelectedReader);
	m_ReaderSelectCombo.GetLBText(m_ReaderSelectCombo.GetCurSel(), m_SelectedReaderInfo);
	m_ReaderSelectCombo.GetLBText(m_ReaderSelectCombo.GetCurSel(), m_Message);
	m_Message = m_Message + " selected";
	UpdateData(false);
}

void CTestPCSCDlg::OnChangeEditMessage() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	
}

void CTestPCSCDlg::OnConnectBtn() 
{
	// TODO: Add your control notification handler code here
	SCManager.m_SCardConnect(SCManager.m_SelectedReader,m_Message);
}

void CTestPCSCDlg::OnOK() 
{
	// TODO: Add extra validation here
	// make sure the context gets released
	SCManager.m_SCardReleaseContext();
	CDialog::OnOK();
}

void CTestPCSCDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	// make sure the context gets released
	SCManager.m_SCardReleaseContext();
	CDialog::OnCancel();
}
